totemconfig.h File Reference
`#include <netinet/in.h>`
`#include <corosync/corotypes.h>`
`#include <qb/qbloop.h>`
`#include <corosync/totem/totempg.h>`
`#include "totemsrp.h"`
Include dependency graph for totemconfig.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | TOTEM_CONFIG_WARNING_MEMBERS_IGNORED (1<<1)
#define | TOTEM_CONFIG_WARNING_MEMBERS_DEPRECATED (1<<2)
#define | TOTEM_CONFIG_WARNING_TOTEM_NODEID_SET (1<<3)
#define | TOTEM_CONFIG_BINDNETADDR_NODELIST_SET (1<<4)

## Functions

int | totem_config_read (struct totem_config *totem_config, const char **error_string, uint64_t *warnings)
int | totem_config_validate (struct totem_config *totem_config, const char **error_string)
int | totem_config_keyread (struct totem_config *totem_config, icmap_map_t map, const char **error_string)
int | totem_config_find_local_addr_in_nodelist (struct totem_config *totem_config, const char *ipaddr_key_prefix, unsigned int *node_pos)
void | totem_volatile_config_read (struct totem_config *totem_config, icmap_map_t temp_map, const char *deleted_key)
int | totem_reread_crypto_config (struct totem_config *totem_config, icmap_map_t map, const char **error_string)
int | totem_volatile_config_validate (struct totem_config *totem_config, icmap_map_t temp_map, const char **error_string)
int | totemconfig_configure_new_params (struct totem_config *totem_config, icmap_map_t map, const char **error_string)
int | totemconfig_commit_new_params (struct totem_config *totem_config, icmap_map_t map)

## Macro Definition Documentation

## TOTEM_CONFIG_BINDNETADDR_NODELIST_SET

#define TOTEM_CONFIG_BINDNETADDR_NODELIST_SET (1<<4)

Definition at line 48 of file totemconfig.h.

Referenced by main(), and totem_config_read().

## TOTEM_CONFIG_WARNING_MEMBERS_DEPRECATED

#define TOTEM_CONFIG_WARNING_MEMBERS_DEPRECATED (1<<2)

Definition at line 46 of file totemconfig.h.

Referenced by main().

## TOTEM_CONFIG_WARNING_MEMBERS_IGNORED

#define TOTEM_CONFIG_WARNING_MEMBERS_IGNORED (1<<1)

Definition at line 45 of file totemconfig.h.

Referenced by main().

## TOTEM_CONFIG_WARNING_TOTEM_NODEID_SET

#define TOTEM_CONFIG_WARNING_TOTEM_NODEID_SET (1<<3)

Definition at line 47 of file totemconfig.h.

Referenced by main(), and totem_config_read().

## Function Documentation

## totem_config_find_local_addr_in_nodelist()

int totem_config_find_local_addr_in_nodelist | ( | struct totem_config * | totem_config,
|  | const char * | ipaddr_key_prefix,
|  | unsigned int * | node_pos )

extern

## totem_config_keyread()

int totem_config_keyread | ( | struct totem_config * | totem_config,
|  | icmap_map_t | map,
|  | const char ** | error_string )

extern

Definition at line 2221 of file totemconfig.c.

References COROSYSCONFDIR, totem_config::crypto_changed, totem_config::crypto_cipher_type, totem_config::crypto_hash_type, CS_OK, icmap_get_r(), icmap_get_string_r(), totem_config::private_key, totem_config::private_key_len, TOTEM_PRIVATE_KEY_LEN_MAX, and TOTEM_PRIVATE_KEY_LEN_MIN.

Referenced by totem_config_read(), and totem_reread_crypto_config().

## totem_config_read()

int totem_config_read | ( | struct totem_config * | totem_config,
|  | const char ** | error_string,
|  | uint64_t * | warnings )

extern

Definition at line 1788 of file totemconfig.c.

References totem_config::broadcast_use, totem_config::clear_node_high_bit, totem_interface::configured, totem_config::crypto_changed, totem_config::crypto_index, CS_OK, icmap_get_global_map(), icmap_get_string(), icmap_get_uint16(), icmap_get_uint32(), ICMAP_KEYNAME_MAXLEN, icmap_set_ro_access(), icmap_set_string(), icmap_set_uint16(), INTERFACE_MAX, totem_config::interfaces, totem_interface::ip_port, totem_config::ip_version, totem_config::link_mode, totem_interface::mcast_addr, totem_interface::member_list, totem_config::net_mtu, totem_config::node_id, totem_ip_address::nodeid, totem_config::threads, TOTEM_CONFIG_BINDNETADDR_NODELIST_SET, totem_config_keyread(), TOTEM_CONFIG_WARNING_TOTEM_NODEID_SET, TOTEM_IP_VERSION_4, TOTEM_LINK_MODE_BYTES, TOTEM_TRANSPORT_KNET, TOTEM_TRANSPORT_UDP, TOTEM_TRANSPORT_UDPU, totem_volatile_config_read(), totemip_parse(), totemip_print(), totem_config::transport_number, and totem_config::version.

Referenced by main().

## totem_config_validate()

int totem_config_validate | ( | struct totem_config * | totem_config,
|  | const char ** | error_string )

extern

Definition at line 2005 of file totemconfig.c.

References totem_interface::bindnet, totem_config::broadcast_use, totem_interface::configured, totem_config::crypto_cipher_type, totem_config::crypto_hash_type, CS_OK, totem_ip_address::family, icmap_get_global_map(), icmap_get_uint32(), INTERFACE_MAX, totem_config::interfaces, totem_interface::ip_port, totem_interface::knet_link_priority, totem_config::link_mode, totem_interface::mcast_addr, totem_config::net_mtu, totem_config::node_id, TOTEM_TRANSPORT_KNET, TOTEM_TRANSPORT_UDP, totem_volatile_config_validate(), totemip_is_mcast(), totem_config::transport_number, totem_interface::ttl, UDP_NETMTU, and totem_config::version.

Referenced by main().

## totem_reread_crypto_config()

int totem_reread_crypto_config | ( | struct totem_config * | totem_config,
|  | icmap_map_t | map,
|  | const char ** | error_string )

extern

Definition at line 2293 of file totemconfig.c.

References totem_config_keyread().

## totem_volatile_config_read()

void totem_volatile_config_read | ( | struct totem_config * | totem_config,
|  | icmap_map_t | temp_map,
|  | const char * | deleted_key )

extern

Definition at line 311 of file totemconfig.c.

References BLOCK_UNLISTED_IPS, CANCEL_TOKEN_HOLD_ON_RETRANSMIT, DOWNCHECK_TIMEOUT, FAIL_TO_RECV_CONST, icmap_get_uint32_r(), icmap_set_uint32_r(), totem_config::interfaces, JOIN_TIMEOUT, KNET_MTU, KNET_PMTUD_INTERVAL, MAX_MESSAGES, MAX_NETWORK_DELAY, totem_interface::member_count, MERGE_TIMEOUT, MISS_COUNT_CONST, SEQNO_UNCHANGED_CONST, TOKEN_COEFFICIENT, totem_config::token_retransmit_timeout, TOKEN_RETRANSMITS_BEFORE_LOSS_CONST, totem_config::token_retransmits_before_loss_const, TOKEN_TIMEOUT, totem_config::token_timeout, TOKEN_WARNING, and WINDOW_SIZE.

Referenced by totem_config_read().

## totem_volatile_config_validate()

int totem_volatile_config_validate | ( | struct totem_config * | totem_config,
|  | icmap_map_t | temp_map,
|  | const char ** | error_string )

extern

Definition at line 380 of file totemconfig.c.

References totem_interface::configured, totem_config::consensus_timeout, CS_OK, totem_config::downcheck_timeout, totem_ip_address::family, icmap_get_string_r(), icmap_get_uint32_r(), ICMAP_KEYNAME_MAXLEN, INTERFACE_MAX, totem_config::interfaces, totem_config::join_timeout, totem_config::max_network_delay, totem_interface::member_count, totem_interface::member_list, totem_config::merge_timeout, MINIMUM_TIMEOUT, MINIMUM_TIMEOUT_HOLD, totem_config::token_hold_timeout, totem_config::token_retransmit_timeout, totem_config::token_timeout, totem_config::token_warning, and totemip_print().

Referenced by totem_config_validate().

## totemconfig_commit_new_params()

int totemconfig_commit_new_params | ( | struct totem_config * | totem_config,
|  | icmap_map_t | map )

extern

Definition at line 2421 of file totemconfig.c.

References INTERFACE_MAX, totem_config::interfaces, totem_config::orig_interfaces, and totempg_reconfigure().

Referenced by main_iface_change_fn().

## totemconfig_configure_new_params()

int totemconfig_configure_new_params | ( | struct totem_config * | totem_config,
|  | icmap_map_t | map,
|  | const char ** | error_string )

extern

Definition at line 2398 of file totemconfig.c.

References log_printf, and LOGSYS_LEVEL_DEBUG.